"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const api_1 = require("../api");
const base_test_1 = require("./base-test");
const configuration_1 = require("../configuration");
describe('Balances API', () => {
    let client;
    beforeAll(() => {
        const config = new configuration_1.Configuration({ accessToken: "key_xxxxxxxx" });
        client = new api_1.BalancesApi(config, base_test_1.baseTest.BasePath);
    });
    describe("general", () => {
        it('should be defined', () => {
            expect(client).toBeInstanceOf(api_1.BalancesApi);
        });
    });
    describe('balances Get Balance', () => {
        it('should return balance', () => __awaiter(void 0, void 0, void 0, function* () {
            const response = (yield client.getBalance("es")).data;
            expect(response).toBeDefined();
            expect(response.available[0].amount).toEqual(413343);
            expect(response.cashout_retention_amount[0].amount).toEqual(0);
            expect(response.cashout_retention_amount[0].currency).toEqual("MXN");
        }));
    });
});
