/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { BlacklistRuleResponse } from '../model';
import { CreateRiskRulesData } from '../model';
import { DeletedBlacklistRuleResponse } from '../model';
import { DeletedWhitelistRuleResponse } from '../model';
import { RiskRulesList } from '../model';
import { WhitelistlistRuleResponse } from '../model';
/**
 * AntifraudApi - axios parameter creator
 * @export
 */
export declare const AntifraudApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Create blacklisted rule
     * @param {CreateRiskRulesData} createRiskRulesData requested field for blacklist rule
     * @param {CreateRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleBlacklist: (createRiskRulesData: CreateRiskRulesData, acceptLanguage?: CreateRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create whitelisted rule
     * @param {CreateRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {CreateRiskRulesData} [createRiskRulesData]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleWhitelist: (acceptLanguage?: CreateRuleWhitelistAcceptLanguageEnum, createRiskRulesData?: CreateRiskRulesData, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete blacklisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleBlacklist: (id: string, acceptLanguage?: DeleteRuleBlacklistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete whitelisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleWhitelist: (id: string, acceptLanguage?: DeleteRuleWhitelistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Return all rules
     * @summary Get list of blacklisted rules
     * @param {GetRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleBlacklist: (acceptLanguage?: GetRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Return all rules
     * @summary Get a list of whitelisted rules
     * @param {GetRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleWhitelist: (acceptLanguage?: GetRuleWhitelistAcceptLanguageEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * AntifraudApi - functional programming interface
 * @export
 */
export declare const AntifraudApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Create blacklisted rule
     * @param {CreateRiskRulesData} createRiskRulesData requested field for blacklist rule
     * @param {CreateRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleBlacklist(createRiskRulesData: CreateRiskRulesData, acceptLanguage?: CreateRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BlacklistRuleResponse>>;
    /**
     *
     * @summary Create whitelisted rule
     * @param {CreateRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {CreateRiskRulesData} [createRiskRulesData]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleWhitelist(acceptLanguage?: CreateRuleWhitelistAcceptLanguageEnum, createRiskRulesData?: CreateRiskRulesData, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WhitelistlistRuleResponse>>;
    /**
     *
     * @summary Delete blacklisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleBlacklist(id: string, acceptLanguage?: DeleteRuleBlacklistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeletedBlacklistRuleResponse>>;
    /**
     *
     * @summary Delete whitelisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleWhitelist(id: string, acceptLanguage?: DeleteRuleWhitelistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DeletedWhitelistRuleResponse>>;
    /**
     * Return all rules
     * @summary Get list of blacklisted rules
     * @param {GetRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleBlacklist(acceptLanguage?: GetRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RiskRulesList>>;
    /**
     * Return all rules
     * @summary Get a list of whitelisted rules
     * @param {GetRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleWhitelist(acceptLanguage?: GetRuleWhitelistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RiskRulesList>>;
};
/**
 * AntifraudApi - factory interface
 * @export
 */
export declare const AntifraudApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Create blacklisted rule
     * @param {CreateRiskRulesData} createRiskRulesData requested field for blacklist rule
     * @param {CreateRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleBlacklist(createRiskRulesData: CreateRiskRulesData, acceptLanguage?: CreateRuleBlacklistAcceptLanguageEnum, options?: any): AxiosPromise<BlacklistRuleResponse>;
    /**
     *
     * @summary Create whitelisted rule
     * @param {CreateRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {CreateRiskRulesData} [createRiskRulesData]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRuleWhitelist(acceptLanguage?: CreateRuleWhitelistAcceptLanguageEnum, createRiskRulesData?: CreateRiskRulesData, options?: any): AxiosPromise<WhitelistlistRuleResponse>;
    /**
     *
     * @summary Delete blacklisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleBlacklist(id: string, acceptLanguage?: DeleteRuleBlacklistAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<DeletedBlacklistRuleResponse>;
    /**
     *
     * @summary Delete whitelisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRuleWhitelist(id: string, acceptLanguage?: DeleteRuleWhitelistAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<DeletedWhitelistRuleResponse>;
    /**
     * Return all rules
     * @summary Get list of blacklisted rules
     * @param {GetRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleBlacklist(acceptLanguage?: GetRuleBlacklistAcceptLanguageEnum, options?: any): AxiosPromise<RiskRulesList>;
    /**
     * Return all rules
     * @summary Get a list of whitelisted rules
     * @param {GetRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRuleWhitelist(acceptLanguage?: GetRuleWhitelistAcceptLanguageEnum, options?: any): AxiosPromise<RiskRulesList>;
};
/**
 * AntifraudApi - interface
 * @export
 * @interface AntifraudApi
 */
export interface AntifraudApiInterface {
    /**
     *
     * @summary Create blacklisted rule
     * @param {CreateRiskRulesData} createRiskRulesData requested field for blacklist rule
     * @param {CreateRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    createRuleBlacklist(createRiskRulesData: CreateRiskRulesData, acceptLanguage?: CreateRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): AxiosPromise<BlacklistRuleResponse>;
    /**
     *
     * @summary Create whitelisted rule
     * @param {CreateRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {CreateRiskRulesData} [createRiskRulesData]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    createRuleWhitelist(acceptLanguage?: CreateRuleWhitelistAcceptLanguageEnum, createRiskRulesData?: CreateRiskRulesData, options?: RawAxiosRequestConfig): AxiosPromise<WhitelistlistRuleResponse>;
    /**
     *
     * @summary Delete blacklisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    deleteRuleBlacklist(id: string, acceptLanguage?: DeleteRuleBlacklistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<DeletedBlacklistRuleResponse>;
    /**
     *
     * @summary Delete whitelisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    deleteRuleWhitelist(id: string, acceptLanguage?: DeleteRuleWhitelistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<DeletedWhitelistRuleResponse>;
    /**
     * Return all rules
     * @summary Get list of blacklisted rules
     * @param {GetRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    getRuleBlacklist(acceptLanguage?: GetRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): AxiosPromise<RiskRulesList>;
    /**
     * Return all rules
     * @summary Get a list of whitelisted rules
     * @param {GetRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApiInterface
     */
    getRuleWhitelist(acceptLanguage?: GetRuleWhitelistAcceptLanguageEnum, options?: RawAxiosRequestConfig): AxiosPromise<RiskRulesList>;
}
/**
 * AntifraudApi - object-oriented interface
 * @export
 * @class AntifraudApi
 * @extends {BaseAPI}
 */
export declare class AntifraudApi extends BaseAPI implements AntifraudApiInterface {
    /**
     *
     * @summary Create blacklisted rule
     * @param {CreateRiskRulesData} createRiskRulesData requested field for blacklist rule
     * @param {CreateRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    createRuleBlacklist(createRiskRulesData: CreateRiskRulesData, acceptLanguage?: CreateRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<BlacklistRuleResponse, any>>;
    /**
     *
     * @summary Create whitelisted rule
     * @param {CreateRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {CreateRiskRulesData} [createRiskRulesData]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    createRuleWhitelist(acceptLanguage?: CreateRuleWhitelistAcceptLanguageEnum, createRiskRulesData?: CreateRiskRulesData, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<WhitelistlistRuleResponse, any>>;
    /**
     *
     * @summary Delete blacklisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    deleteRuleBlacklist(id: string, acceptLanguage?: DeleteRuleBlacklistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<DeletedBlacklistRuleResponse, any>>;
    /**
     *
     * @summary Delete whitelisted rule
     * @param {string} id Identifier of the resource
     * @param {DeleteRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    deleteRuleWhitelist(id: string, acceptLanguage?: DeleteRuleWhitelistAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<DeletedWhitelistRuleResponse, any>>;
    /**
     * Return all rules
     * @summary Get list of blacklisted rules
     * @param {GetRuleBlacklistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    getRuleBlacklist(acceptLanguage?: GetRuleBlacklistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<RiskRulesList, any>>;
    /**
     * Return all rules
     * @summary Get a list of whitelisted rules
     * @param {GetRuleWhitelistAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AntifraudApi
     */
    getRuleWhitelist(acceptLanguage?: GetRuleWhitelistAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<RiskRulesList, any>>;
}
/**
 * @export
 */
export declare const CreateRuleBlacklistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type CreateRuleBlacklistAcceptLanguageEnum = typeof CreateRuleBlacklistAcceptLanguageEnum[keyof typeof CreateRuleBlacklistAcceptLanguageEnum];
/**
 * @export
 */
export declare const CreateRuleWhitelistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type CreateRuleWhitelistAcceptLanguageEnum = typeof CreateRuleWhitelistAcceptLanguageEnum[keyof typeof CreateRuleWhitelistAcceptLanguageEnum];
/**
 * @export
 */
export declare const DeleteRuleBlacklistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type DeleteRuleBlacklistAcceptLanguageEnum = typeof DeleteRuleBlacklistAcceptLanguageEnum[keyof typeof DeleteRuleBlacklistAcceptLanguageEnum];
/**
 * @export
 */
export declare const DeleteRuleWhitelistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type DeleteRuleWhitelistAcceptLanguageEnum = typeof DeleteRuleWhitelistAcceptLanguageEnum[keyof typeof DeleteRuleWhitelistAcceptLanguageEnum];
/**
 * @export
 */
export declare const GetRuleBlacklistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetRuleBlacklistAcceptLanguageEnum = typeof GetRuleBlacklistAcceptLanguageEnum[keyof typeof GetRuleBlacklistAcceptLanguageEnum];
/**
 * @export
 */
export declare const GetRuleWhitelistAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetRuleWhitelistAcceptLanguageEnum = typeof GetRuleWhitelistAcceptLanguageEnum[keyof typeof GetRuleWhitelistAcceptLanguageEnum];
