/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { CreateCustomerPaymentMethodsRequest } from '../model';
import { CreateCustomerPaymentMethodsResponse } from '../model';
import { GetPaymentMethodResponse } from '../model';
import { UpdateCustomerPaymentMethodsResponse } from '../model';
import { UpdatePaymentMethods } from '../model';
/**
 * PaymentMethodsApi - axios parameter creator
 * @export
 */
export declare const PaymentMethodsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Create a payment method for a customer.
     * @summary Create Payment Method
     * @param {string} id Identifier of the resource
     * @param {CreateCustomerPaymentMethodsRequest} createCustomerPaymentMethodsRequest requested field for customer payment methods
     * @param {CreateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createCustomerPaymentMethods: (id: string, createCustomerPaymentMethodsRequest: CreateCustomerPaymentMethodsRequest, acceptLanguage?: CreateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Delete an existing payment method
     * @summary Delete Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {DeleteCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteCustomerPaymentMethods: (id: string, paymentMethodId: string, acceptLanguage?: DeleteCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Get a list of Payment Methods
     * @summary Get Payment Methods
     * @param {string} id Identifier of the resource
     * @param {GetCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCustomerPaymentMethods: (id: string, acceptLanguage?: GetCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, next?: string, previous?: string, search?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Gets a payment Method that corresponds to a customer ID.
     * @summary Update Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {UpdatePaymentMethods} updatePaymentMethods requested field for customer payment methods
     * @param {UpdateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateCustomerPaymentMethods: (id: string, paymentMethodId: string, updatePaymentMethods: UpdatePaymentMethods, acceptLanguage?: UpdateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * PaymentMethodsApi - functional programming interface
 * @export
 */
export declare const PaymentMethodsApiFp: (configuration?: Configuration) => {
    /**
     * Create a payment method for a customer.
     * @summary Create Payment Method
     * @param {string} id Identifier of the resource
     * @param {CreateCustomerPaymentMethodsRequest} createCustomerPaymentMethodsRequest requested field for customer payment methods
     * @param {CreateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createCustomerPaymentMethods(id: string, createCustomerPaymentMethodsRequest: CreateCustomerPaymentMethodsRequest, acceptLanguage?: CreateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CreateCustomerPaymentMethodsResponse>>;
    /**
     * Delete an existing payment method
     * @summary Delete Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {DeleteCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteCustomerPaymentMethods(id: string, paymentMethodId: string, acceptLanguage?: DeleteCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UpdateCustomerPaymentMethodsResponse>>;
    /**
     * Get a list of Payment Methods
     * @summary Get Payment Methods
     * @param {string} id Identifier of the resource
     * @param {GetCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCustomerPaymentMethods(id: string, acceptLanguage?: GetCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, next?: string, previous?: string, search?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetPaymentMethodResponse>>;
    /**
     * Gets a payment Method that corresponds to a customer ID.
     * @summary Update Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {UpdatePaymentMethods} updatePaymentMethods requested field for customer payment methods
     * @param {UpdateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateCustomerPaymentMethods(id: string, paymentMethodId: string, updatePaymentMethods: UpdatePaymentMethods, acceptLanguage?: UpdateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UpdateCustomerPaymentMethodsResponse>>;
};
/**
 * PaymentMethodsApi - factory interface
 * @export
 */
export declare const PaymentMethodsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Create a payment method for a customer.
     * @summary Create Payment Method
     * @param {string} id Identifier of the resource
     * @param {CreateCustomerPaymentMethodsRequest} createCustomerPaymentMethodsRequest requested field for customer payment methods
     * @param {CreateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createCustomerPaymentMethods(id: string, createCustomerPaymentMethodsRequest: CreateCustomerPaymentMethodsRequest, acceptLanguage?: CreateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<CreateCustomerPaymentMethodsResponse>;
    /**
     * Delete an existing payment method
     * @summary Delete Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {DeleteCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteCustomerPaymentMethods(id: string, paymentMethodId: string, acceptLanguage?: DeleteCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<UpdateCustomerPaymentMethodsResponse>;
    /**
     * Get a list of Payment Methods
     * @summary Get Payment Methods
     * @param {string} id Identifier of the resource
     * @param {GetCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCustomerPaymentMethods(id: string, acceptLanguage?: GetCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, next?: string, previous?: string, search?: string, options?: any): AxiosPromise<GetPaymentMethodResponse>;
    /**
     * Gets a payment Method that corresponds to a customer ID.
     * @summary Update Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {UpdatePaymentMethods} updatePaymentMethods requested field for customer payment methods
     * @param {UpdateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateCustomerPaymentMethods(id: string, paymentMethodId: string, updatePaymentMethods: UpdatePaymentMethods, acceptLanguage?: UpdateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<UpdateCustomerPaymentMethodsResponse>;
};
/**
 * PaymentMethodsApi - interface
 * @export
 * @interface PaymentMethodsApi
 */
export interface PaymentMethodsApiInterface {
    /**
     * Create a payment method for a customer.
     * @summary Create Payment Method
     * @param {string} id Identifier of the resource
     * @param {CreateCustomerPaymentMethodsRequest} createCustomerPaymentMethodsRequest requested field for customer payment methods
     * @param {CreateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApiInterface
     */
    createCustomerPaymentMethods(id: string, createCustomerPaymentMethodsRequest: CreateCustomerPaymentMethodsRequest, acceptLanguage?: CreateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<CreateCustomerPaymentMethodsResponse>;
    /**
     * Delete an existing payment method
     * @summary Delete Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {DeleteCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApiInterface
     */
    deleteCustomerPaymentMethods(id: string, paymentMethodId: string, acceptLanguage?: DeleteCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<UpdateCustomerPaymentMethodsResponse>;
    /**
     * Get a list of Payment Methods
     * @summary Get Payment Methods
     * @param {string} id Identifier of the resource
     * @param {GetCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApiInterface
     */
    getCustomerPaymentMethods(id: string, acceptLanguage?: GetCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, next?: string, previous?: string, search?: string, options?: RawAxiosRequestConfig): AxiosPromise<GetPaymentMethodResponse>;
    /**
     * Gets a payment Method that corresponds to a customer ID.
     * @summary Update Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {UpdatePaymentMethods} updatePaymentMethods requested field for customer payment methods
     * @param {UpdateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApiInterface
     */
    updateCustomerPaymentMethods(id: string, paymentMethodId: string, updatePaymentMethods: UpdatePaymentMethods, acceptLanguage?: UpdateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<UpdateCustomerPaymentMethodsResponse>;
}
/**
 * PaymentMethodsApi - object-oriented interface
 * @export
 * @class PaymentMethodsApi
 * @extends {BaseAPI}
 */
export declare class PaymentMethodsApi extends BaseAPI implements PaymentMethodsApiInterface {
    /**
     * Create a payment method for a customer.
     * @summary Create Payment Method
     * @param {string} id Identifier of the resource
     * @param {CreateCustomerPaymentMethodsRequest} createCustomerPaymentMethodsRequest requested field for customer payment methods
     * @param {CreateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApi
     */
    createCustomerPaymentMethods(id: string, createCustomerPaymentMethodsRequest: CreateCustomerPaymentMethodsRequest, acceptLanguage?: CreateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<CreateCustomerPaymentMethodsResponse, any>>;
    /**
     * Delete an existing payment method
     * @summary Delete Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {DeleteCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApi
     */
    deleteCustomerPaymentMethods(id: string, paymentMethodId: string, acceptLanguage?: DeleteCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<UpdateCustomerPaymentMethodsResponse, any>>;
    /**
     * Get a list of Payment Methods
     * @summary Get Payment Methods
     * @param {string} id Identifier of the resource
     * @param {GetCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApi
     */
    getCustomerPaymentMethods(id: string, acceptLanguage?: GetCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, next?: string, previous?: string, search?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<GetPaymentMethodResponse, any>>;
    /**
     * Gets a payment Method that corresponds to a customer ID.
     * @summary Update Payment Method
     * @param {string} id Identifier of the resource
     * @param {string} paymentMethodId Identifier of the payment method
     * @param {UpdatePaymentMethods} updatePaymentMethods requested field for customer payment methods
     * @param {UpdateCustomerPaymentMethodsAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PaymentMethodsApi
     */
    updateCustomerPaymentMethods(id: string, paymentMethodId: string, updatePaymentMethods: UpdatePaymentMethods, acceptLanguage?: UpdateCustomerPaymentMethodsAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<UpdateCustomerPaymentMethodsResponse, any>>;
}
/**
 * @export
 */
export declare const CreateCustomerPaymentMethodsAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type CreateCustomerPaymentMethodsAcceptLanguageEnum = typeof CreateCustomerPaymentMethodsAcceptLanguageEnum[keyof typeof CreateCustomerPaymentMethodsAcceptLanguageEnum];
/**
 * @export
 */
export declare const DeleteCustomerPaymentMethodsAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type DeleteCustomerPaymentMethodsAcceptLanguageEnum = typeof DeleteCustomerPaymentMethodsAcceptLanguageEnum[keyof typeof DeleteCustomerPaymentMethodsAcceptLanguageEnum];
/**
 * @export
 */
export declare const GetCustomerPaymentMethodsAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetCustomerPaymentMethodsAcceptLanguageEnum = typeof GetCustomerPaymentMethodsAcceptLanguageEnum[keyof typeof GetCustomerPaymentMethodsAcceptLanguageEnum];
/**
 * @export
 */
export declare const UpdateCustomerPaymentMethodsAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type UpdateCustomerPaymentMethodsAcceptLanguageEnum = typeof UpdateCustomerPaymentMethodsAcceptLanguageEnum[keyof typeof UpdateCustomerPaymentMethodsAcceptLanguageEnum];
