/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { GetWebhookKeysResponse } from '../model';
import { WebhookKeyCreateResponse } from '../model';
import { WebhookKeyDeleteResponse } from '../model';
import { WebhookKeyRequest } from '../model';
import { WebhookKeyResponse } from '../model';
import { WebhookKeyUpdateRequest } from '../model';
/**
 * WebhookKeysApi - axios parameter creator
 * @export
 */
export declare const WebhookKeysApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Create a webhook key
     * @summary Create Webhook Key
     * @param {CreateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyRequest} [webhookKeyRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createWebhookKey: (acceptLanguage?: CreateWebhookKeyAcceptLanguageEnum, webhookKeyRequest?: WebhookKeyRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete Webhook key
     * @param {string} id Identifier of the resource
     * @param {DeleteWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteWebhookKey: (id: string, acceptLanguage?: DeleteWebhookKeyAcceptLanguageEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Webhook Key
     * @param {string} id Identifier of the resource
     * @param {GetWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKey: (id: string, acceptLanguage?: GetWebhookKeyAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Consume the list of webhook keys you have
     * @summary Get List of Webhook Keys
     * @param {GetWebhookKeysAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKeys: (acceptLanguage?: GetWebhookKeysAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, search?: string, next?: string, previous?: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * updates an existing webhook key
     * @summary Update Webhook Key
     * @param {string} id Identifier of the resource
     * @param {UpdateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyUpdateRequest} [webhookKeyUpdateRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateWebhookKey: (id: string, acceptLanguage?: UpdateWebhookKeyAcceptLanguageEnum, webhookKeyUpdateRequest?: WebhookKeyUpdateRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * WebhookKeysApi - functional programming interface
 * @export
 */
export declare const WebhookKeysApiFp: (configuration?: Configuration) => {
    /**
     * Create a webhook key
     * @summary Create Webhook Key
     * @param {CreateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyRequest} [webhookKeyRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createWebhookKey(acceptLanguage?: CreateWebhookKeyAcceptLanguageEnum, webhookKeyRequest?: WebhookKeyRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebhookKeyCreateResponse>>;
    /**
     *
     * @summary Delete Webhook key
     * @param {string} id Identifier of the resource
     * @param {DeleteWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteWebhookKey(id: string, acceptLanguage?: DeleteWebhookKeyAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebhookKeyDeleteResponse>>;
    /**
     *
     * @summary Get Webhook Key
     * @param {string} id Identifier of the resource
     * @param {GetWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKey(id: string, acceptLanguage?: GetWebhookKeyAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebhookKeyResponse>>;
    /**
     * Consume the list of webhook keys you have
     * @summary Get List of Webhook Keys
     * @param {GetWebhookKeysAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKeys(acceptLanguage?: GetWebhookKeysAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, search?: string, next?: string, previous?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetWebhookKeysResponse>>;
    /**
     * updates an existing webhook key
     * @summary Update Webhook Key
     * @param {string} id Identifier of the resource
     * @param {UpdateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyUpdateRequest} [webhookKeyUpdateRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateWebhookKey(id: string, acceptLanguage?: UpdateWebhookKeyAcceptLanguageEnum, webhookKeyUpdateRequest?: WebhookKeyUpdateRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebhookKeyResponse>>;
};
/**
 * WebhookKeysApi - factory interface
 * @export
 */
export declare const WebhookKeysApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Create a webhook key
     * @summary Create Webhook Key
     * @param {CreateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyRequest} [webhookKeyRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createWebhookKey(acceptLanguage?: CreateWebhookKeyAcceptLanguageEnum, webhookKeyRequest?: WebhookKeyRequest, options?: any): AxiosPromise<WebhookKeyCreateResponse>;
    /**
     *
     * @summary Delete Webhook key
     * @param {string} id Identifier of the resource
     * @param {DeleteWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteWebhookKey(id: string, acceptLanguage?: DeleteWebhookKeyAcceptLanguageEnum, options?: any): AxiosPromise<WebhookKeyDeleteResponse>;
    /**
     *
     * @summary Get Webhook Key
     * @param {string} id Identifier of the resource
     * @param {GetWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKey(id: string, acceptLanguage?: GetWebhookKeyAcceptLanguageEnum, xChildCompanyId?: string, options?: any): AxiosPromise<WebhookKeyResponse>;
    /**
     * Consume the list of webhook keys you have
     * @summary Get List of Webhook Keys
     * @param {GetWebhookKeysAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebhookKeys(acceptLanguage?: GetWebhookKeysAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, search?: string, next?: string, previous?: string, options?: any): AxiosPromise<GetWebhookKeysResponse>;
    /**
     * updates an existing webhook key
     * @summary Update Webhook Key
     * @param {string} id Identifier of the resource
     * @param {UpdateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyUpdateRequest} [webhookKeyUpdateRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateWebhookKey(id: string, acceptLanguage?: UpdateWebhookKeyAcceptLanguageEnum, webhookKeyUpdateRequest?: WebhookKeyUpdateRequest, options?: any): AxiosPromise<WebhookKeyResponse>;
};
/**
 * WebhookKeysApi - interface
 * @export
 * @interface WebhookKeysApi
 */
export interface WebhookKeysApiInterface {
    /**
     * Create a webhook key
     * @summary Create Webhook Key
     * @param {CreateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyRequest} [webhookKeyRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApiInterface
     */
    createWebhookKey(acceptLanguage?: CreateWebhookKeyAcceptLanguageEnum, webhookKeyRequest?: WebhookKeyRequest, options?: RawAxiosRequestConfig): AxiosPromise<WebhookKeyCreateResponse>;
    /**
     *
     * @summary Delete Webhook key
     * @param {string} id Identifier of the resource
     * @param {DeleteWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApiInterface
     */
    deleteWebhookKey(id: string, acceptLanguage?: DeleteWebhookKeyAcceptLanguageEnum, options?: RawAxiosRequestConfig): AxiosPromise<WebhookKeyDeleteResponse>;
    /**
     *
     * @summary Get Webhook Key
     * @param {string} id Identifier of the resource
     * @param {GetWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApiInterface
     */
    getWebhookKey(id: string, acceptLanguage?: GetWebhookKeyAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): AxiosPromise<WebhookKeyResponse>;
    /**
     * Consume the list of webhook keys you have
     * @summary Get List of Webhook Keys
     * @param {GetWebhookKeysAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApiInterface
     */
    getWebhookKeys(acceptLanguage?: GetWebhookKeysAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, search?: string, next?: string, previous?: string, options?: RawAxiosRequestConfig): AxiosPromise<GetWebhookKeysResponse>;
    /**
     * updates an existing webhook key
     * @summary Update Webhook Key
     * @param {string} id Identifier of the resource
     * @param {UpdateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyUpdateRequest} [webhookKeyUpdateRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApiInterface
     */
    updateWebhookKey(id: string, acceptLanguage?: UpdateWebhookKeyAcceptLanguageEnum, webhookKeyUpdateRequest?: WebhookKeyUpdateRequest, options?: RawAxiosRequestConfig): AxiosPromise<WebhookKeyResponse>;
}
/**
 * WebhookKeysApi - object-oriented interface
 * @export
 * @class WebhookKeysApi
 * @extends {BaseAPI}
 */
export declare class WebhookKeysApi extends BaseAPI implements WebhookKeysApiInterface {
    /**
     * Create a webhook key
     * @summary Create Webhook Key
     * @param {CreateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyRequest} [webhookKeyRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApi
     */
    createWebhookKey(acceptLanguage?: CreateWebhookKeyAcceptLanguageEnum, webhookKeyRequest?: WebhookKeyRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<WebhookKeyCreateResponse, any>>;
    /**
     *
     * @summary Delete Webhook key
     * @param {string} id Identifier of the resource
     * @param {DeleteWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApi
     */
    deleteWebhookKey(id: string, acceptLanguage?: DeleteWebhookKeyAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<WebhookKeyDeleteResponse, any>>;
    /**
     *
     * @summary Get Webhook Key
     * @param {string} id Identifier of the resource
     * @param {GetWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApi
     */
    getWebhookKey(id: string, acceptLanguage?: GetWebhookKeyAcceptLanguageEnum, xChildCompanyId?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<WebhookKeyResponse, any>>;
    /**
     * Consume the list of webhook keys you have
     * @summary Get List of Webhook Keys
     * @param {GetWebhookKeysAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {string} [xChildCompanyId] In the case of a holding company, the company id of the child company to which will process the request.
     * @param {number} [limit] The numbers of items to return, the maximum value is 250
     * @param {string} [search] General order search, e.g. by mail, reference etc.
     * @param {string} [next] next page
     * @param {string} [previous] previous page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApi
     */
    getWebhookKeys(acceptLanguage?: GetWebhookKeysAcceptLanguageEnum, xChildCompanyId?: string, limit?: number, search?: string, next?: string, previous?: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<GetWebhookKeysResponse, any>>;
    /**
     * updates an existing webhook key
     * @summary Update Webhook Key
     * @param {string} id Identifier of the resource
     * @param {UpdateWebhookKeyAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {WebhookKeyUpdateRequest} [webhookKeyUpdateRequest]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebhookKeysApi
     */
    updateWebhookKey(id: string, acceptLanguage?: UpdateWebhookKeyAcceptLanguageEnum, webhookKeyUpdateRequest?: WebhookKeyUpdateRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<WebhookKeyResponse, any>>;
}
/**
 * @export
 */
export declare const CreateWebhookKeyAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type CreateWebhookKeyAcceptLanguageEnum = typeof CreateWebhookKeyAcceptLanguageEnum[keyof typeof CreateWebhookKeyAcceptLanguageEnum];
/**
 * @export
 */
export declare const DeleteWebhookKeyAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type DeleteWebhookKeyAcceptLanguageEnum = typeof DeleteWebhookKeyAcceptLanguageEnum[keyof typeof DeleteWebhookKeyAcceptLanguageEnum];
/**
 * @export
 */
export declare const GetWebhookKeyAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetWebhookKeyAcceptLanguageEnum = typeof GetWebhookKeyAcceptLanguageEnum[keyof typeof GetWebhookKeyAcceptLanguageEnum];
/**
 * @export
 */
export declare const GetWebhookKeysAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetWebhookKeysAcceptLanguageEnum = typeof GetWebhookKeysAcceptLanguageEnum[keyof typeof GetWebhookKeysAcceptLanguageEnum];
/**
 * @export
 */
export declare const UpdateWebhookKeyAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type UpdateWebhookKeyAcceptLanguageEnum = typeof UpdateWebhookKeyAcceptLanguageEnum[keyof typeof UpdateWebhookKeyAcceptLanguageEnum];
