/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { BalanceResponse } from '../model';
/**
 * BalancesApi - axios parameter creator
 * @export
 */
export declare const BalancesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Get a company\'s balance
     * @summary Get a company\'s balance
     * @param {GetBalanceAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getBalance: (acceptLanguage?: GetBalanceAcceptLanguageEnum, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * BalancesApi - functional programming interface
 * @export
 */
export declare const BalancesApiFp: (configuration?: Configuration) => {
    /**
     * Get a company\'s balance
     * @summary Get a company\'s balance
     * @param {GetBalanceAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getBalance(acceptLanguage?: GetBalanceAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BalanceResponse>>;
};
/**
 * BalancesApi - factory interface
 * @export
 */
export declare const BalancesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Get a company\'s balance
     * @summary Get a company\'s balance
     * @param {GetBalanceAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getBalance(acceptLanguage?: GetBalanceAcceptLanguageEnum, options?: any): AxiosPromise<BalanceResponse>;
};
/**
 * BalancesApi - interface
 * @export
 * @interface BalancesApi
 */
export interface BalancesApiInterface {
    /**
     * Get a company\'s balance
     * @summary Get a company\'s balance
     * @param {GetBalanceAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BalancesApiInterface
     */
    getBalance(acceptLanguage?: GetBalanceAcceptLanguageEnum, options?: RawAxiosRequestConfig): AxiosPromise<BalanceResponse>;
}
/**
 * BalancesApi - object-oriented interface
 * @export
 * @class BalancesApi
 * @extends {BaseAPI}
 */
export declare class BalancesApi extends BaseAPI implements BalancesApiInterface {
    /**
     * Get a company\'s balance
     * @summary Get a company\'s balance
     * @param {GetBalanceAcceptLanguageEnum} [acceptLanguage] Use for knowing which language to use
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BalancesApi
     */
    getBalance(acceptLanguage?: GetBalanceAcceptLanguageEnum, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<BalanceResponse, any>>;
}
/**
 * @export
 */
export declare const GetBalanceAcceptLanguageEnum: {
    readonly es: "es";
    readonly en: "en";
};
export type GetBalanceAcceptLanguageEnum = typeof GetBalanceAcceptLanguageEnum[keyof typeof GetBalanceAcceptLanguageEnum];
