/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { ChargeRequest } from './charge-request';
import { CheckoutRequest } from './checkout-request';
import { CustomerShippingContacts } from './customer-shipping-contacts';
import { OrderDiscountLinesRequest } from './order-discount-lines-request';
import { OrderFiscalEntityRequest } from './order-fiscal-entity-request';
import { OrderRequestCustomerInfo } from './order-request-customer-info';
import { OrderTaxRequest } from './order-tax-request';
import { Product } from './product';
import { ShippingRequest } from './shipping-request';
/**
 * a order
 * @export
 * @interface OrderRequest
 */
export interface OrderRequest {
    /**
     * List of [charges](https://developers.conekta.com/v2.1.0/reference/orderscreatecharge) that are applied to the order
     * @type {Array<ChargeRequest>}
     * @memberof OrderRequest
     */
    'charges'?: Array<ChargeRequest>;
    /**
     *
     * @type {CheckoutRequest}
     * @memberof OrderRequest
     */
    'checkout'?: CheckoutRequest;
    /**
     * Currency with which the payment will be made. It uses the 3-letter code of the [International Standard ISO 4217.](https://es.wikipedia.org/wiki/ISO_4217)
     * @type {string}
     * @memberof OrderRequest
     */
    'currency': string;
    /**
     *
     * @type {OrderRequestCustomerInfo}
     * @memberof OrderRequest
     */
    'customer_info': OrderRequestCustomerInfo;
    /**
     * List of [discounts](https://developers.conekta.com/v2.1.0/reference/orderscreatediscountline) that are applied to the order. You must have at least one discount.
     * @type {Array<OrderDiscountLinesRequest>}
     * @memberof OrderRequest
     */
    'discount_lines'?: Array<OrderDiscountLinesRequest>;
    /**
     *
     * @type {OrderFiscalEntityRequest}
     * @memberof OrderRequest
     */
    'fiscal_entity'?: OrderFiscalEntityRequest;
    /**
     * List of [products](https://developers.conekta.com/v2.1.0/reference/orderscreateproduct) that are sold in the order. You must have at least one product.
     * @type {Array<Product>}
     * @memberof OrderRequest
     */
    'line_items': Array<Product>;
    /**
     * Metadata associated with the order
     * @type {{ [key: string]: any; }}
     * @memberof OrderRequest
     */
    'metadata'?: {
        [key: string]: any;
    };
    /**
     * Allows you to fill out the shipping information at checkout
     * @type {boolean}
     * @memberof OrderRequest
     */
    'needs_shipping_contact'?: boolean;
    /**
     * Indicates whether the order charges must be preauthorized
     * @type {boolean}
     * @memberof OrderRequest
     */
    'pre_authorize'?: boolean;
    /**
     * Indicates the processing mode for the order, either ecommerce, recurrent or validation.
     * @type {string}
     * @memberof OrderRequest
     */
    'processing_mode'?: string;
    /**
     * Indicates the redirection callback upon completion of the 3DS2 flow.
     * @type {string}
     * @memberof OrderRequest
     */
    'return_url'?: string;
    /**
     *
     * @type {CustomerShippingContacts}
     * @memberof OrderRequest
     */
    'shipping_contact'?: CustomerShippingContacts;
    /**
     * List of [shipping costs](https://developers.conekta.com/v2.1.0/reference/orderscreateshipping). If the online store offers digital products.
     * @type {Array<ShippingRequest>}
     * @memberof OrderRequest
     */
    'shipping_lines'?: Array<ShippingRequest>;
    /**
     * List of [taxes](https://developers.conekta.com/v2.1.0/reference/orderscreatetaxes) that are applied to the order.
     * @type {Array<OrderTaxRequest>}
     * @memberof OrderRequest
     */
    'tax_lines'?: Array<OrderTaxRequest>;
    /**
     * Indicates the 3DS2 mode for the order, either smart or strict.
     * @type {string}
     * @memberof OrderRequest
     */
    'three_ds_mode'?: string;
}
