/**
 * Conekta API
 * Conekta sdk
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: engineering@conekta.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { ChargeResponseChannel } from './charge-response-channel';
import { OrderFiscalEntityResponse } from './order-fiscal-entity-response';
import { OrderNextActionResponse } from './order-next-action-response';
import { OrderResponseCharges } from './order-response-charges';
import { OrderResponseCheckout } from './order-response-checkout';
import { OrderResponseCustomerInfo } from './order-response-customer-info';
import { OrderResponseDiscountLines } from './order-response-discount-lines';
import { OrderResponseProducts } from './order-response-products';
import { OrderResponseShippingContact } from './order-response-shipping-contact';
/**
 * order response
 * @export
 * @interface OrderResponse
 */
export interface OrderResponse {
    /**
     * The total amount to be collected in cents
     * @type {number}
     * @memberof OrderResponse
     */
    'amount'?: number;
    /**
     * The total amount refunded in cents
     * @type {number}
     * @memberof OrderResponse
     */
    'amount_refunded'?: number;
    /**
     *
     * @type {ChargeResponseChannel}
     * @memberof OrderResponse
     */
    'channel'?: ChargeResponseChannel;
    /**
     *
     * @type {OrderResponseCharges}
     * @memberof OrderResponse
     */
    'charges'?: OrderResponseCharges;
    /**
     *
     * @type {OrderResponseCheckout}
     * @memberof OrderResponse
     */
    'checkout'?: OrderResponseCheckout;
    /**
     * The time at which the object was created in seconds since the Unix epoch
     * @type {number}
     * @memberof OrderResponse
     */
    'created_at'?: number;
    /**
     * The three-letter ISO 4217 currency code. The currency of the order.
     * @type {string}
     * @memberof OrderResponse
     */
    'currency'?: string;
    /**
     *
     * @type {OrderResponseCustomerInfo}
     * @memberof OrderResponse
     */
    'customer_info'?: OrderResponseCustomerInfo;
    /**
     *
     * @type {OrderResponseDiscountLines}
     * @memberof OrderResponse
     */
    'discount_lines'?: OrderResponseDiscountLines;
    /**
     *
     * @type {OrderFiscalEntityResponse}
     * @memberof OrderResponse
     */
    'fiscal_entity'?: OrderFiscalEntityResponse | null;
    /**
     *
     * @type {string}
     * @memberof OrderResponse
     */
    'id'?: string;
    /**
     *
     * @type {boolean}
     * @memberof OrderResponse
     */
    'is_refundable'?: boolean;
    /**
     *
     * @type {OrderResponseProducts}
     * @memberof OrderResponse
     */
    'line_items'?: OrderResponseProducts;
    /**
     * Whether the object exists in live mode or test mode
     * @type {boolean}
     * @memberof OrderResponse
     */
    'livemode'?: boolean;
    /**
     * Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
     * @type {{ [key: string]: any; }}
     * @memberof OrderResponse
     */
    'metadata'?: {
        [key: string]: any;
    };
    /**
     *
     * @type {OrderNextActionResponse}
     * @memberof OrderResponse
     */
    'next_action'?: OrderNextActionResponse;
    /**
     * String representing the object’s type. Objects of the same type share the same value.
     * @type {string}
     * @memberof OrderResponse
     */
    'object'?: string;
    /**
     * The payment status of the order.
     * @type {string}
     * @memberof OrderResponse
     */
    'payment_status'?: string;
    /**
     * Indicates the processing mode for the order, either ecommerce, recurrent or validation.
     * @type {string}
     * @memberof OrderResponse
     */
    'processing_mode'?: string;
    /**
     *
     * @type {OrderResponseShippingContact}
     * @memberof OrderResponse
     */
    'shipping_contact'?: OrderResponseShippingContact;
    /**
     * The time at which the object was last updated in seconds since the Unix epoch
     * @type {number}
     * @memberof OrderResponse
     */
    'updated_at'?: number;
}
